%define anolis_release 1
%global pypi_name peft
%global pypi_version 0.8.2

Name:           python-%{pypi_name}
Version:        %{pypi_version}
Release:        %{anolis_release}%{?dist}
Summary:        Parameter-Efficient Fine-Tuning (PEFT)

License:        Apache
URL:            https://github.com/huggingface/peft
Source0:        %{pypi_source}
BuildArch:      noarch

BuildRequires:  python3-devel pytest
BuildRequires:  python3dist(accelerate) >= 0.21
BuildRequires:  python3dist(black) >= 22
BuildRequires:  python3dist(datasets)
BuildRequires:  python3dist(huggingface-hub) >= 0.17
BuildRequires:  python3dist(numpy) >= 1.17
BuildRequires:  python3dist(packaging) >= 20
BuildRequires:  python3dist(psutil)
BuildRequires:  python3dist(pytest)
BuildRequires:  python3dist(pytest-cov)
BuildRequires:  python3dist(pytest-xdist)
BuildRequires:  python3dist(pyyaml)
BuildRequires:  python3dist(safetensors)
BuildRequires:  python3dist(scipy)
BuildRequires:  python3dist(setuptools)
BuildRequires:  python3dist(torch) >= 1.13
BuildRequires:  python3dist(tqdm)
BuildRequires:  python3dist(transformers)
BuildRequires:  python3dist(urllib3)

%description
Parameter-Efficient Fine-Tuning (PEFT) methods enable efficient adaptation of pre-trained language 
models (PLMs) to various downstream applications without fine-tuning all the model's parameters. 
Fine-tuning large-scale PLMs is often prohibitively costly. In this regard, PEFT methods only fine-tune 
a small number of (extra) model parameters, thereby greatly decreasing the computational and storage 
costs. Recent State-of-the-Art PEFT techniques achieve performance comparable to that of full fine-tuning.

%package -n     python3-%{pypi_name}
Summary:        %{summary}
%{?python_provide:%python_provide python3-%{pypi_name}}

Requires:       python3dist(accelerate) >= 0.21
Requires:       python3dist(black) >= 22
Requires:       python3dist(datasets)
Requires:       python3dist(huggingface-hub) >= 0.17
Requires:       python3dist(numpy) >= 1.17
Requires:       python3dist(packaging) >= 20
Requires:       python3dist(psutil)
Requires:       python3dist(pytest)
Requires:       python3dist(pytest-cov)
Requires:       python3dist(pytest-xdist)
Requires:       python3dist(pyyaml)
Requires:       python3dist(safetensors)
Requires:       python3dist(scipy)
Requires:       python3dist(setuptools)
Requires:       python3dist(torch) >= 1.13
Requires:       python3dist(tqdm)
Requires:       python3dist(transformers)
Requires:       python3dist(urllib3)

%description -n python3-%{pypi_name}
Parameter-Efficient Fine-Tuning (PEFT) methods enable efficient adaptation of pre-trained language 
models (PLMs) to various downstream applications without fine-tuning all the model's parameters. 
Fine-tuning large-scale PLMs is often prohibitively costly. In this regard, PEFT methods only fine-tune 
a small number of (extra) model parameters, thereby greatly decreasing the computational and storage 
costs. Recent State-of-the-Art PEFT techniques achieve performance comparable to that of full fine-tuning.

%prep
%autosetup -n %{pypi_name}-%{pypi_version}
# Remove bundled egg-info
rm -rf %{pypi_name}.egg-info

%build
%py3_build

%install
%py3_install

%files -n python3-%{pypi_name}
%license LICENSE
%doc README.md
%{python3_sitelib}/%{pypi_name}
%{python3_sitelib}/%{pypi_name}-%{pypi_version}-py%{python3_version}.egg-info

%changelog
* Tue Feb 06 2024 zhongling.h <zhonglingh@linux.alibaba.com> - 0.8.2-1
- Initial package.